---
title: "Create a new project"
description: "Creates a new project with the provided details"
---

> Documentation Index
> Fetch the complete documentation index at: https://docs.testandaccept.com/llms.txt
> Use this file to discover all available pages before exploring further.

Path: Test And Accept API › Projects

`POST /projects`

Creates a new project with the provided details

## Authentication

- `bearerAuth`, http, header `Authorization`, format `tnda_ token`

## Request body

_Required._

- `name` (`projects-create.name`; string, required)
  - minLength 1; maxLength 255
- `description` (`projects-create.description`; string, optional)
- `status` (`projects-create.status`; string, optional)
  - one of `"active"`, `"on_hold"`, `"completed"`, `"archived"`; default `"active"`
- `clientId` (`projects-create.clientId`; string, optional)
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000)$`
- `contactId` (`projects-create.contactId`; string, optional)
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000)$`
- `startDate` (`projects-create.startDate`; string, optional)
  - format `date-time`; pattern `^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$`
- `endDate` (`projects-create.endDate`; string, optional)
  - format `date-time`; pattern `^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$`

## Example request

```json
{
  "name": "string",
  "description": "string",
  "status": "active",
  "clientId": "5e505642-9024-474d-9434-e5a44f505cc5",
  "contactId": "b5ec5d98-4bee-4da1-ad24-dde86346cb1d",
  "startDate": "2019-08-24T14:15:22Z",
  "endDate": "2019-08-24T14:15:22Z"
}
```

## Code samples

### cURL

```bash
curl --request POST \
  --url https://api.testandaccept.com/api/rest/projects \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "name": "string",
  "description": "string",
  "status": "active",
  "clientId": "5e505642-9024-474d-9434-e5a44f505cc5",
  "contactId": "b5ec5d98-4bee-4da1-ad24-dde86346cb1d",
  "startDate": "2019-08-24T14:15:22Z",
  "endDate": "2019-08-24T14:15:22Z"
}
'
```

### TypeScript

```typescript
const url = 'https://api.testandaccept.com/api/rest/projects';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json', Authorization: 'Bearer <token>'},
  body: JSON.stringify({
    name: 'string',
    description: 'string',
    status: 'active',
    clientId: '5e505642-9024-474d-9434-e5a44f505cc5',
    contactId: 'b5ec5d98-4bee-4da1-ad24-dde86346cb1d',
    startDate: '2019-08-24T14:15:22Z',
    endDate: '2019-08-24T14:15:22Z'
  })
};

fetch(url, options)
  .then(res => res.json())
  .then(json => console.log(json))
  .catch(err => console.error(err));
```

### Python

```python
import requests

url = "https://api.testandaccept.com/api/rest/projects"

payload = {
    "name": "string",
    "description": "string",
    "status": "active",
    "clientId": "5e505642-9024-474d-9434-e5a44f505cc5",
    "contactId": "b5ec5d98-4bee-4da1-ad24-dde86346cb1d",
    "startDate": "2019-08-24T14:15:22Z",
    "endDate": "2019-08-24T14:15:22Z"
}
headers = {
    "Content-Type": "application/json",
    "Authorization": "Bearer <token>"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

## Responses

### 200

Successful response

#### Example

```json
{
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "name": "string",
  "description": "string",
  "status": "string",
  "clientId": "5e505642-9024-474d-9434-e5a44f505cc5",
  "clientName": "string",
  "contactId": "b5ec5d98-4bee-4da1-ad24-dde86346cb1d",
  "startDate": "2019-08-24T14:15:22Z",
  "endDate": "2019-08-24T14:15:22Z",
  "ownerUserId": "string",
  "organizationId": "string",
  "isPinned": true,
  "pinnedAt": "2019-08-24T14:15:22Z",
  "sowCount": 0,
  "createdAt": "2019-08-24T14:15:22Z",
  "updatedAt": "2019-08-24T14:15:22Z"
}
```

- `id` (`projects-create.response.200.id`; string, required)
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000)$`
- `name` (`projects-create.response.200.name`; string, required)
- `status` (`projects-create.response.200.status`; string, required)
- `clientId` (`projects-create.response.200.clientId`; any of, required)
  - any of: `string`, `null`
- `contactId` (`projects-create.response.200.contactId`; any of, required)
  - any of: `string`, `null`
- `startDate` (`projects-create.response.200.startDate`; any of, required)
  - any of: `string`, `null`
- `endDate` (`projects-create.response.200.endDate`; any of, required)
  - any of: `string`, `null`
- `ownerUserId` (`projects-create.response.200.ownerUserId`; string, required)
- `organizationId` (`projects-create.response.200.organizationId`; any of, required)
  - any of: `string`, `null`
- `isPinned` (`projects-create.response.200.isPinned`; boolean, required)
- `pinnedAt` (`projects-create.response.200.pinnedAt`; any of, required)
  - any of: `string`, `null`
- `sowCount` (`projects-create.response.200.sowCount`; number, required)
- `createdAt` (`projects-create.response.200.createdAt`; string, required)
  - format `date-time`; pattern `^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$`
- `updatedAt` (`projects-create.response.200.updatedAt`; string, required)
  - format `date-time`; pattern `^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$`
- `description` (`projects-create.response.200.description`; any of, optional)
  - any of: `string`, `null`
- `clientName` (`projects-create.response.200.clientName`; any of, optional)
  - any of: `string`, `null`

### 400

Invalid input data

#### Example

```json
{
  "code": "BAD_REQUEST",
  "message": "Invalid input data",
  "issues": []
}
```

- `message` (`projects-create.response.400.message`; string, required) — The error message
  - example `"Invalid input data"`
- `code` (`projects-create.response.400.code`; string, required) — The error code
  - example `"BAD_REQUEST"`
- `issues` (`projects-create.response.400.issues`; array<object>, optional) — An array of issues that were responsible for the error
  - example `[]`
  - `message` (`projects-create.response.400.issues.message`; string, required)

### 401

Authorization not provided

#### Example

```json
{
  "code": "UNAUTHORIZED",
  "message": "Authorization not provided",
  "issues": []
}
```

- `message` (`projects-create.response.401.message`; string, required) — The error message
  - example `"Authorization not provided"`
- `code` (`projects-create.response.401.code`; string, required) — The error code
  - example `"UNAUTHORIZED"`
- `issues` (`projects-create.response.401.issues`; array<object>, optional) — An array of issues that were responsible for the error
  - example `[]`
  - `message` (`projects-create.response.401.issues.message`; string, required)

### 403

Insufficient access

#### Example

```json
{
  "code": "FORBIDDEN",
  "message": "Insufficient access",
  "issues": []
}
```

- `message` (`projects-create.response.403.message`; string, required) — The error message
  - example `"Insufficient access"`
- `code` (`projects-create.response.403.code`; string, required) — The error code
  - example `"FORBIDDEN"`
- `issues` (`projects-create.response.403.issues`; array<object>, optional) — An array of issues that were responsible for the error
  - example `[]`
  - `message` (`projects-create.response.403.issues.message`; string, required)

### 500

Internal server error

#### Example

```json
{
  "code": "INTERNAL_SERVER_ERROR",
  "message": "Internal server error",
  "issues": []
}
```

- `message` (`projects-create.response.500.message`; string, required) — The error message
  - example `"Internal server error"`
- `code` (`projects-create.response.500.code`; string, required) — The error code
  - example `"INTERNAL_SERVER_ERROR"`
- `issues` (`projects-create.response.500.issues`; array<object>, optional) — An array of issues that were responsible for the error
  - example `[]`
  - `message` (`projects-create.response.500.issues.message`; string, required)


Source: https://docs.testandaccept.com/reference/projects/create/index.md
